def make_thing(self, nx=5, ny=5): s = self co = "CenterOfBoundBox" fudge = 1 unit_x = s.x_nom + s.xy_extra + s.x_spacing unit_y = s.y_nom + s.xy_extra + s.y_spacing x_len = nx * unit_x y_len = ny * unit_y z_len = s.shelf_height + s.wall_height one_void = CQ().box(s.x_nom + s.xy_extra, s.y_nom + s.xy_extra, s.shelf_height, centered=(True, True, False)).edges("|Z").fillet( s.cut_tool_diameter / 2) tweezer_void = CQ().box(unit_x + fudge, s.tweezer_allowance_width, s.wall_height + s.tweezer_allowance_depth, centered=(True, True, False)) CQ.undercutRelief2D = tbutil.undercutRelief2D h00 = CQ().box(x_len, y_len, z_len, centered=(True, True, False)) # limits box #h01 = h00.faces('>Z').workplane().rarray(x_len/nx, y_len/ny, nx, ny, center=True).rect(unit_x+fudge, s.tweezer_allowance_width).cutBlind(-s.wall_height-s.tweezer_allowance_depth) # x tweezer cuts #h02 = h01.faces('>Z').workplane().rarray(x_len/nx, y_len/ny, nx, ny, center=True).rect(s.tweezer_allowance_width, unit_y+fudge).cutBlind(-s.wall_height-s.tweezer_allowance_depth) # y tweezer cuts h01 = h00.faces('>Z').workplane().rarray( x_len / nx, y_len / ny, nx, ny, center=True).undercutRelief2D( s.y_nom + s.xy_extra, s.y_nom + s.xy_extra, diameter=s.cut_tool_diameter).cutBlind( -s.wall_height) # substrate pockets all_voids = h00.faces('<Z').workplane(invert=True).rarray( x_len / nx, y_len / ny, nx, ny, center=True).eachpoint( lambda l: one_void.val().located(l)) # voids under h02 = h01.cut(all_voids) tweezer_voids = h00.faces('>Z').workplane(invert=True).rarray( x_len / nx, y_len / ny, nx, ny, center=True).eachpoint( lambda l: tweezer_void.val().located(l)) # tweezer voids h03 = h02.cut(tweezer_voids) tweezer_voids2 = h00.faces('>Z').workplane(invert=True).rarray( x_len / nx, y_len / ny, nx, ny, center=True).eachpoint(lambda l: tweezer_void.rotate( (0, 0, 0), (0, 0, 1), 90).val().located(l)) # tweezer voids h04 = h03.cut(tweezer_voids2) return h04
def make_tower_plate(self): towers = CQ().add(self.cu_base).toPending().extrude(self.cu_base_t) towers = towers.faces("<Z[-2]").workplane().add( self.cu_towers).translate( (0, 0, self.cu_base_t)).toPending().extrude(self.cu_tower_h) towers = towers.faces("<Z[-2]").workplane().add( self.cu_nubs).translate( (0, 0, self.cu_base_t)).toPending().extrude(self.cu_nub_h) towers = towers.add(self.plate_mounts).toPending().cutThruAll() towers = towers.add(self.cu_dowel_pf).toPending().cutThruAll() towers = towers.translate( (0, 0, -self.cu_base_t - self.pcb_thickness / 2 - self.pcb_spacer_h)) return (towers)
def make_heater_plate(self): heater = CQ().add(self.base_plate).toPending().extrude(self.heater_t) heater = heater.faces(">Z[-1]").workplane().add( self.plate_mounts).translate( (0, 0, self.heater_t)).toPending().cutBlind(-self.screw_depth) heater = heater.translate((0, 0, -self.heater_t - self.cu_base_t - self.pcb_thickness / 2 - self.pcb_spacer_h)) return (heater)
def _make_pcb(what): """build the actual passthrough PCB""" # this copies some logic in the eachpoint() function so that we can use each() which is safer base_plane = self.plane base = base_plane.location if isinstance(what, (cq.Vector, cq.Shape)): loc = base.inverse * cq.Location(base_plane, what.Center()) elif isinstance(what, cq.Sketch): loc = base.inverse * cq.Location(base_plane, what._faces.Center()) else: loc = what pcb = CQ().workplane(offset=-wall_depth - board_inner_depth) pcb = pcb.rect(board_width, pcbt).extrude(until=board_inner_depth + wall_depth + board_outer_depth) pcb = pcb.edges("|Y").fillet(pcb_corner) # put in screws with holes hardware = cadquery.Assembly() pcb = pcb.faces(">Y").workplane(**u.cobb).rarray( board_width - 2 * block_width / 2, board_inner_depth + board_outer_depth + wall_depth - 2 * pt_pcb_mount_hole_offset[0], 2, 2).clearanceHole(pcb_scr, fit="Close", counterSunk=False, baseAssembly=hardware) if hw_asy is not None: hw_asy.add(hardware, loc=base * loc) # put in pin0 holes pcb = pcb.faces(">Y").workplane(**u.copo, origin=(0, 0, 0)).pushPoints(p0pts).circle( pin0_holed / 2).cutThruAll() return pcb.findSolid().moved(base * loc)
def mkwalls( aso: cadquery.Assembly, height: float, cshift, extents, hps, zbase: float, ): """the chamber walls""" name = "walls" color = cadquery.Color("GRAY55") thickness = 12 inner = (extents[0] - 2 * thickness, extents[1] - 2 * thickness) inner_shift = cshift outer_fillet = 2 inner_fillet = 6 chamfer = 0.75 nut = HexNut(size="M5-0.8", fastener_type="iso4033") # HNN-M5-A2 flat_to_flat = math.sin(60 * math.pi / 180) * nut.nut_diameter + 0.25 gas_fitting_hole_diameter = 20.6375 # 13/16" gas_fitting_recess = 6.35 gas_fitting_flat_to_flat = 22.22 + 0.28 gas_fitting_diameter = 25.66 + 0.34 back_holes_shift = 45 back_holes_spacing = 27 front_holes_spacing = 75 fitting_step_xy = ( 3, 15) # dims of the little step for the vac fitting alignment fitting_step_center = (-fitting_step_xy[0] / 2 + inner[0] / 2 + cshift[0], extents[1] / 2 - fitting_step_xy[1] / 2 - thickness) wp = CQ().workplane(offset=zbase).sketch() wp = wp.push([cshift ]).rect(extents[0], extents[1], mode="a").reset().vertices().fillet(outer_fillet) wp = wp.push([inner_shift]).rect(inner[0], inner[1], mode="s").reset() dummy_xy = (fitting_step_xy[0], inner[1]) dummy_center = (fitting_step_center[0], 0) wp = wp.push([dummy_center]).rect( *dummy_xy, mode="a") # add on a dummy bit that we'll mostly subtract away wp = wp.finalize().extrude(height).edges("|Z").fillet(inner_fillet) sub_xy = (40, inner[1] - fitting_step_xy[1]) sub_center = (-sub_xy[0] / 2 + inner[0] / 2 + cshift[0], -fitting_step_xy[1] / 2) wp2 = CQ().workplane(offset=zbase).sketch().push([sub_center ]).rect(*sub_xy, mode="a") wp2 = wp2.finalize().extrude(height).edges("|Z").fillet(inner_fillet) wp = wp.cut(wp2) # wp = CQ().workplane(offset=zbase).sketch() # wp = wp.push([cshift]).rect(extents[0], extents[1], mode="a").reset().vertices().fillet(outer_fillet) # wp = wp.push([inner_shift]).rect(inner[0], inner[1], mode="s") # .reset().vertices().fillet(inner_fillet) # wp = wp.finalize().extrude(height) wp: cadquery.Workplane # shouldn't have to do this (needed for type hints) wall_hardware = cq.Assembly(None, name="wall_hardware") # corner holes (with nuts and nut pockets) wp = wp.faces(">Z").workplane( **u.copo, offset=-nut.nut_thickness).pushPoints(hps).clearanceHole( fastener=nut, fit="Close", counterSunk=False, baseAssembly=wall_hardware) wp = wp.faces(">Z").workplane(**u.copo).sketch().push(hps[0:4:3]).rect( flat_to_flat, nut.nut_diameter, angle=45).reset().push( hps[1:3]).rect(flat_to_flat, nut.nut_diameter, angle=-45).reset().vertices().fillet( nut.nut_diameter / 4).finalize().cutBlind(-nut.nut_thickness) # chamfers wp = wp.faces(">Z").edges(">>X").chamfer(chamfer) # gas holes with recesses wp = wp.faces("<X").workplane(**u.cobb).center( back_holes_shift, 0).rarray(back_holes_spacing, 1, 2, 1).hole(diameter=gas_fitting_hole_diameter, depth=thickness) # wp = wp.faces("<X").workplane(**u.cobb).center(back_holes_shift, 0).sketch().rarray(back_holes_spacing, 1, 2, 1).rect(gas_fitting_diameter, gas_fitting_flat_to_flat).reset().vertices().fillet(gas_fitting_diameter / 4).finalize().cutBlind(-gas_fitting_recess) wp = wp.faces("<X").workplane(**u.cobb).center( back_holes_shift, 0).sketch().rect( 2 * gas_fitting_diameter / 2 + back_holes_spacing, gas_fitting_flat_to_flat).reset().vertices().fillet( gas_fitting_diameter / 4).finalize().cutBlind( -gas_fitting_recess) # unify the back holes wp = wp.faces(">X").workplane(**u.cobb).rarray( front_holes_spacing, 1, 2, 1).hole(diameter=gas_fitting_hole_diameter, depth=thickness) wp = wp.faces(">X").workplane(**u.cobb).sketch().rarray( front_holes_spacing, 1, 2, 1).rect(gas_fitting_diameter, gas_fitting_flat_to_flat).reset().vertices().fillet( gas_fitting_diameter / 4).finalize().cutBlind(-gas_fitting_recess) # that's part number polymax 230X2N70 o_ring_thickness = 2 o_ring_inner_diameter = 230 ooffset = 17 # two times the o-ring path's center offset from the outer edge of the walls # cut the lid o-ring groove wp = wp.faces(">Z").workplane(**u.cobb).mk_groove( ring_cs=o_ring_thickness, follow_pending_wires=False, ring_id=o_ring_inner_diameter, gland_x=extents[0] - ooffset, gland_y=extents[1] - ooffset, hardware=wall_hardware) # cut the base o-ring groove wp = wp.faces("<Z").workplane(**u.cobb).mk_groove( ring_cs=o_ring_thickness, follow_pending_wires=False, ring_id=o_ring_inner_diameter, gland_x=extents[0] - ooffset, gland_y=extents[1] - ooffset, hardware=wall_hardware) # get pipe fitting geometry a_pipe_fitting = u.import_step( wrk_dir.joinpath( "components", "5483T93_Miniature Nickel-Plated Brass Pipe Fitting.step")) a_pipe_fitting = a_pipe_fitting.translate( (0, 0, -6.35 - gas_fitting_recess)) pipe_fitting_asy = cadquery.Assembly(a_pipe_fitting.rotate( axisStartPoint=(0, 0, 0), axisEndPoint=(0, 0, 1), angleDegrees=30), name="one_pipe_fitting") # move the pipe fittings to their wall holes wppf = wp.faces(">X").workplane(**u.cobb).center( front_holes_spacing / 2, 0) pipe_fitting_asy.loc = wppf.plane.location wall_hardware.add(pipe_fitting_asy, name="front_right_gas_fitting") wppf = wppf.center(-front_holes_spacing, 0) pipe_fitting_asy.loc = wppf.plane.location wall_hardware.add(pipe_fitting_asy, name="front_left_gas_fitting") wppf = wp.faces("<X").workplane(**u.cobb).center( back_holes_shift + back_holes_spacing / 2, 0) pipe_fitting_asy.loc = wppf.plane.location wall_hardware.add(pipe_fitting_asy, name="rear_left_gas_fitting") wppf = wppf.center(-back_holes_spacing, 0) pipe_fitting_asy.loc = wppf.plane.location wall_hardware.add(pipe_fitting_asy, name="rear_right_gas_fitting") # get bonded washer geometry, part 229-6277 bonded_washer = u.import_step( wrk_dir.joinpath("components", "hutchinson_ljf_207242.stp")) bonded_washer = bonded_washer.rotate(axisStartPoint=(0, 0, 0), axisEndPoint=(0, 1, 0), angleDegrees=90).translate( (0, 0, 1.25)) bonded_washer_asy = cadquery.Assembly(bonded_washer, name="one_bonded_washer") # move bonded washers to their wall holes washer_thickness = 2.5 wpbw = wp.faces(">X").workplane(**u.cobb, offset=-thickness - washer_thickness).center( -front_holes_spacing / 2, 0) bonded_washer_asy.loc = wpbw.plane.location wall_hardware.add(bonded_washer_asy, name="front_right_bonded_washer") wpbw = wpbw.center(front_holes_spacing, 0) bonded_washer_asy.loc = wpbw.plane.location wall_hardware.add(bonded_washer_asy, name="front_left_bonded_washer") wpbw = wp.faces("<X[-5]").workplane(**u.cobb).center( -back_holes_shift - back_holes_spacing / 2, 0) bonded_washer_asy.loc = wpbw.plane.location wall_hardware.add(bonded_washer_asy, name="rear_right_bonded_washer") wpbw = wpbw.center(back_holes_spacing, 0) bonded_washer_asy.loc = wpbw.plane.location wall_hardware.add(bonded_washer_asy, name="rear_left_bonded_washer") aso.add(wall_hardware.toCompound(), name="wall_hardware", color=cadquery.Color(hardware_color)) # passthrough details pcb_scr_head_d_safe = 6 n_header_pins = 50 header_length = n_header_pins / 2 * 2.54 + 7.62 # n*0.1 + 0.3 inches support_block_width = 7 pt_pcb_width = 2 * (support_block_width / 2 + pcb_scr_head_d_safe / 2) + header_length pt_pcb_outer_depth = 8.89 + 0.381 # 0.35 + 0.15 inches pt_pcb_inner_depth = 8.89 + 0.381 # 0.35 + 0.15 inches pt_center_offset = 28.65 # so that the internal passthrough connector aligns with the one in the chamber # make the electrical passthrough pt_asy = cadquery.Assembly( ) # this will hold the passthrough part that gets created # pcb_asy = cadquery.Assembly() # this will hold the pcb part that gets created pcb_asy = None # dont generate the base PCB (will probably later import the detailed board model) hw_asy = cadquery.Assembly( ) # this will hold the pcb part that gets created ptt = 5.5 # passthrough thickness, reduce a bit from default (which was half wall thickness) to prevent some thin walls close to an o-ring gland wp = wp.faces("<X").workplane(**u.cobb).center( -pt_center_offset, 0).make_oringer(board_width=pt_pcb_width, board_inner_depth=pt_pcb_inner_depth, board_outer_depth=pt_pcb_outer_depth, wall_depth=thickness, part_thickness=ptt, pt_asy=pt_asy, pcb_asy=pcb_asy, hw_asy=hw_asy) # insert passthrough into assembly for asyo in pt_asy.traverse(): part = asyo[1] if isinstance(part.obj, cadquery.occ_impl.shapes.Solid): aso.add(part.obj, name=asyo[0], color=color) if pcb_asy is not None: # insert pcb into assembly for asyo in pcb_asy.traverse(): # insert only one solid object part = asyo[1] if isinstance(part.obj, cadquery.occ_impl.shapes.Solid): aso.add(part.obj, name=asyo[0], color=cadquery.Color("DARKGREEN")) # insert hardware into assembly aso.add(hw_asy.toCompound(), name="passthrough hardware") # add in little detailed PCB a_little_pcb = u.import_step( wrk_dir.joinpath("components", "pt_pcb.step")).translate( (0, 0, -pcb_thickness / 2)) # shift pcb to be z-centered little_pcb = cadquery.Assembly(a_little_pcb.rotate( axisStartPoint=(0, 0, 0), axisEndPoint=(0, 1, 0), angleDegrees=90).rotate(axisStartPoint=(0, 0, 0), axisEndPoint=(0, 0, 1), angleDegrees=90), name="small detailed pcb") asys["squirrel"].add(little_pcb, loc=wp.plane.location, name="little pcb") # for the vac chuck fittings rotation_angle = -155 # degrees vac_fitting_wall_offset = extents[ 1] / 2 - thickness - inner_fillet - 4 # mounting location offset from center wp = wp.faces(">X").workplane(**u.cobb).center( vac_fitting_wall_offset, 0).tapHole(vac_fitting_screw, depth=thickness + fitting_step_xy[0]) vac_chuck_fitting = cadquery.Assembly(a_vac_fitting.rotate( axisStartPoint=(0, 0, 0), axisEndPoint=(0, 0, 1), angleDegrees=rotation_angle), name="outer_wall_vac_fitting") aso.add(vac_chuck_fitting, loc=wp.plane.location, name="vac chuck fitting (wall outer)") nwp = wp.faces(">X").workplane(**u.cobb, invert=True, offset=thickness + fitting_step_xy[0]).center( vac_fitting_wall_offset, 0) vac_chuck_fitting = cadquery.Assembly(a_vac_fitting.rotate( axisStartPoint=(0, 0, 0), axisEndPoint=(0, 0, 1), angleDegrees=-rotation_angle), name="inner_wall_vac_fitting") aso.add(vac_chuck_fitting, loc=nwp.plane.location, name="vac chuck fitting (wall inner)") aso.add(wp, name=name, color=color) # add the walls bulk
def mkbase( aso: cadquery.Assembly, thickness: float, cshift, extents, hps, screw: SocketHeadCapScrew, pedistal_height: float, zbase: float, subs_boost: float, ): """the thermal base""" plate_name = "thermal_plate" vac_name = "vacuum_chuck" color = cadquery.Color("GOLD") fillet_outer = 2 fillet_inner = 10 chamfer = 1 corner_screw_depth = 4.5 pedistal_xy = (161, 152) pedistal_fillet = 10 dowelpts = [(-73, -66), (73, 66)] dowel_nominal_d = 3 # marked on drawing for pressfit with ⌀3K7 # vac chuck clamp screws vacscrew_length = 20 vacscrew = CounterSunkScrew(size="M6-1", fastener_type="iso14581", length=vacscrew_length, simple=no_threads) # SHK-M6-20-V2-A4 vacclamppts = [(-73, -54.75), (-73, 54.75), (73, -54.75), (73, 54.75)] # slot plate clamp screws spscrew_length = 8 spscrew = CounterSunkScrew(size="M3-0.5", fastener_type="iso14581", length=spscrew_length, simple=no_threads) # SHK-M3-8-V2-A4 # setscrew clamping stuff setscrew_len = 30 screw_well_depth = 3 setscrew_recess = pedistal_height + screw_well_depth setscrew = SetScrew(size="M6-1", fastener_type="iso4026", length=setscrew_len, simple=no_threads) # SSU-M6-30-A2 setscrewpts = [(-73, -43.5), (73, 43.5)] # waterblock nuts and holes wb_w = 177.8 wb_mount_offset_from_edge = 7.25 wb_mount_offset = wb_w / 2 - wb_mount_offset_from_edge waterblock_mount_nut = HexNutWithFlange( size="M6-1", fastener_type="din1665", simple=no_threads) # HFFN-M6-A2 wb_mount_points = [ (120, wb_mount_offset), (120, -wb_mount_offset), (-129, wb_mount_offset), (-129, -wb_mount_offset), ] # make the base chunk wp = CQ().workplane(**u.copo, offset=zbase).sketch() wp = wp.push([cshift]).rect(extents[0], extents[1], mode="a") wp = wp.finalize().extrude(thickness) wp: cadquery.Workplane # shouldn't have to do this (needed for type hints) # cut for waterblock mnt ears ear_square = 2 * wb_mount_offset wp = wp.faces("<X").workplane(**u.cobb).rect( xLen=extents[1] - 2 * ear_square, yLen=thickness, centered=True).cutBlind(-(extents[0] - wall_outer[0]) / 2) wp = wp.faces(">X").workplane(**u.cobb).rect( xLen=extents[1] - 2 * ear_square, yLen=thickness, centered=True).cutBlind(-(extents[0] - wall_outer[0]) / 2) wp = wp.edges("|Z exc (<<X or >>X)").fillet(fillet_inner) wp = wp.edges("|Z and (<<X or >>X)").fillet(fillet_outer) # pedistal wp = wp.faces(">Z").workplane(**u.copo, origin=( 0, 0, 0)).sketch().rect( *pedistal_xy).reset().vertices().fillet(pedistal_fillet) wp = wp.finalize().extrude(pedistal_height) hardware = cq.Assembly(None) # a place to keep the harware # corner screws wp = wp.faces("<Z").workplane(**u.copo, offset=-corner_screw_depth).pushPoints( hps).clearanceHole( fastener=screw, fit="Close", baseAssembly=hardware) wp = wp.faces("<Z[-2]").wires().toPending().extrude( corner_screw_depth, combine="cut") # make sure the recessed screw is not buried # dowel holes wp = wp.faces(">Z").workplane(**u.copo).pushPoints(dowelpts).hole( dowel_nominal_d + dowel3_delta_press, depth=pedistal_height) # waterblock mounting wp = wp.faces(">Z[-2]").workplane( **u.copo).pushPoints(wb_mount_points).clearanceHole( fastener=waterblock_mount_nut, counterSunk=False, fit="Loose", baseAssembly=hardware) # vac chuck stuff # split wp = wp.faces(">Z[-2]").workplane(**u.copo).split( keepTop=True, keepBottom=True).clean() btm_piece = wp.solids("<Z").first().edges("not %CIRCLE").chamfer( chamfer) top_piece = wp.solids(">Z").first().edges("not %CIRCLE").chamfer( chamfer) # hole array n_array_x = 4 n_array_y = 5 x_spacing = 35 y_spacing = 29 x_start = (n_array_x - 1) / 2 y_start = (n_array_y - 1) / 2 n_sub_array_x = 8 n_sub_array_y = 2 x_spacing_sub = 3 y_spacing_sub = 10 x_start_sub = (n_sub_array_x - 1) / 2 y_start_sub = (n_sub_array_y - 1) / 2 hole_d = 1 hole_cskd = 1.1 csk_ang = 45 # compute all the vac chuck vent hole points vac_hole_pts = [] # where the vac holes are drilled street_centers = [] # the distribution street y values for i in range(n_array_x): for j in range(n_array_y): for k in range(n_sub_array_x): for l in range(n_sub_array_y): ctrx = (i - x_start) * x_spacing ctry = (j - y_start) * y_spacing offx = (k - x_start_sub) * x_spacing_sub offy = (l - y_start_sub) * y_spacing_sub vac_hole_pts.append((ctrx + offx, ctry + offy)) street_centers.append((0, ctry + offy)) street_centers = list(set(street_centers)) # prune duplicates # boost substrates up so they can't slip under raise_square = (25, 25) raise_fillet = 1 top_piece = CQ(top_piece.findSolid()).faces(">Z").workplane( **u.copo).sketch().rarray( x_spacing, y_spacing, n_array_x, n_array_y).rect(*raise_square).reset().vertices().fillet( raise_fillet).finalize().extrude(subs_boost) # drill all the vac holes top_piece = top_piece.faces(">Z").workplane( **u.copo).pushPoints(vac_hole_pts).cskHole(diameter=hole_d, cskDiameter=hole_cskd, cskAngle=csk_ang) # clamping setscrew threaded holes top_piece = top_piece.faces(">Z").workplane().pushPoints( setscrewpts).tapHole( setscrew, depth=setscrew_recess, baseAssembly=hardware ) # bug prevents this from working correctly, workaround below # clamping setscrew downbumps in the thermal plate btm_piece = CQ(btm_piece.findSolid()).faces(">Z").workplane( **u.copo).pushPoints(setscrewpts).circle( vacscrew.clearance_hole_diameters["Close"] / 2).cutBlind(-screw_well_depth) # vac chuck clamping screws top_piece = top_piece.faces(">Z[-2]").workplane( **u.copo, origin=(0, 0, 0)).pushPoints(vacclamppts).clearanceHole( vacscrew, fit="Close", baseAssembly=hardware) # next line is a hack to make absolutely sure the screws are recessed top_piece = top_piece.faces(">Z[-2]").workplane( **u.copo, origin=(0, 0, 0)).pushPoints(vacclamppts).cskHole( vacscrew.clearance_hole_diameters["Close"], cskDiameter=vacscrew.head_diameter + 1, cskAngle=vacscrew.screw_data["a"]) btm_piece = btm_piece.faces(">Z").workplane(**u.copo, origin=( 0, 0, 0)).pushPoints(vacclamppts).tapHole( setscrew, depth=vacscrew_length - pedistal_height + 1) # threaded holes to attach to # mod the slot plate to include csk screws for clamping for name, part in asys["squirrel"].traverse(): if name == "slot_plate": sp_clamp_pts = [(p[0], p[1] + 5) for p in vacclamppts] sp = part.obj vch_shift_y = -37 vch_shift_x = 3 sp = sp.faces(">Z").workplane(**u.copo, origin=( 0, 0, 0)).rarray(vacclamppts[3][0] * 2 + vch_shift_x, vacclamppts[3][1] * 2 + vch_shift_y, 2, 2).clearanceHole(spscrew, fit="Close", baseAssembly=hardware) # next line is a hack to make absolutely sure the screws are recessed sp = sp.faces(">Z").workplane(**u.copo, origin=( 0, 0, 0)).rarray( vacclamppts[3][0] * 2 + vch_shift_x, vacclamppts[3][1] * 2 + vch_shift_y, 2, 2).cskHole(spscrew.clearance_hole_diameters["Close"], cskDiameter=spscrew.head_diameter + 1, cskAngle=spscrew.screw_data["a"]) part.obj = sp # make threaded holes to attach to, TODO: mark these as M3x0.5 threaded holes in engineering drawing top_piece = top_piece.faces(">Z[-2]").workplane( **u.copo, origin=(0, 0, 0)).rarray(vacclamppts[3][0] * 2 + vch_shift_x, vacclamppts[3][1] * 2 + vch_shift_y, 2, 2).tapHole(spscrew, depth=spscrew_length - 1, counterSunk=False) # compute the hole array extents for o-ring path finding sub_x_length = (n_sub_array_x - 1) * x_spacing_sub + hole_d array_x_length = (n_array_x - 1) * x_spacing + sub_x_length sub_y_length = (n_sub_array_y - 1) * y_spacing_sub + hole_d array_y_length = (n_array_y - 1) * y_spacing + sub_y_length # for the vac chuck fitting vac_fitting_chuck_offset = -0.5 * y_spacing fitting_tap_depth = 20 top_piece = top_piece.faces(">X").workplane(**u.cobb).center( vac_fitting_chuck_offset, 0).tapHole(vac_fitting_screw, depth=fitting_tap_depth) vac_chuck_fitting = cadquery.Assembly(a_vac_fitting.rotate( axisStartPoint=(0, 0, 0), axisEndPoint=(0, 0, 1), angleDegrees=-5), name="chuck_vac_fitting") hardware.add(vac_chuck_fitting, loc=top_piece.plane.location, name="vac chuck fitting") # handle the valve, part number 435-8101 a_valve = u.import_step( wrk_dir.joinpath("components", "VHK2-04F-04F.step")) # a_valve = a_valve.rotate(axisStartPoint=(0, 0, 0), axisEndPoint=(0, 1, 0), angleDegrees=90).translate((0, 7.5, 9)) a_valve = a_valve.translate((0, 7.5, 9)) valve_mnt_spacing = 16.5 valve_mnt_screw_length = 30 valve_body_width = 18 valve_mnt_hole_depth = 15 valve_mnt_screw = PanHeadScrew( size="M4-0.7", fastener_type="iso14583", length=valve_mnt_screw_length) # SHP-M4-30-V2-A4 btm_piece = btm_piece.faces(">X[-2]").workplane(**u.cobb).rarray( valve_mnt_spacing, 1, 2, 1).tapHole(valve_mnt_screw, depth=valve_mnt_hole_depth, counterSunk=False) # cut threaded holes btm_piece = btm_piece.faces(">X[-2]").workplane(**u.cobb).rarray( valve_mnt_spacing, 1, 2, 1).tapHole(valve_mnt_screw, depth=valve_mnt_screw_length - valve_body_width, counterSunk=False, baseAssembly=aso) # add screws aso.add(a_valve, loc=btm_piece.plane.location, name="valve") # handle the elbow, part number 306-5993 an_elbow = u.import_step( wrk_dir.joinpath("components", "3182_04_00.step")) an_elbow = an_elbow.rotate(axisStartPoint=(0, 0, 0), axisEndPoint=(0, 1, 0), angleDegrees=-90).rotate( axisStartPoint=(0, 0, 0), axisEndPoint=(0, 0, 1), angleDegrees=90) # rotate the elbow btm_pln = btm_piece.faces(">X[-2]").workplane( **u.cobb, offset=valve_body_width / 2).center(-26.65, 7.5) # position the elbow aso.add(an_elbow, loc=btm_pln.plane.location, name="elbow") # vac distribution network zdrill_loc = (pedistal_xy[0] / 2 - fitting_tap_depth, 0.5 * y_spacing) zdrill_r = 3 zdrill_depth = -pedistal_height / 2 - 2.5 top_piece = top_piece.faces("<Z").workplane(**u.cobb).pushPoints( [zdrill_loc]).circle(zdrill_r).cutBlind(zdrill_depth) highway_depth = 3 highway_width = 6 street_depth = 2 street_width = 1 top_piece = top_piece.faces("<Z").workplane(**u.cobb).sketch().push([ (zdrill_loc[0] / 2, zdrill_loc[1]) ]).slot(w=zdrill_loc[0], h=highway_width).finalize().cutBlind(-highway_depth) top_piece = top_piece.faces("<Z").workplane(**u.cobb).sketch().slot( w=pedistal_xy[0] - 2 * fitting_tap_depth, h=highway_width, angle=90).finalize().cutBlind(-highway_depth) # cut center highway top_piece = top_piece.faces("<Z").workplane( **u.cobb).sketch().push(street_centers).slot( w=array_x_length - hole_d, h=street_width).finalize().cutBlind( -street_depth) # cut streets # padding to keep the oring groove from bothering the vac holes groove_x_pad = 8 groove_y_pad = 16 # that's part number 196-4941 o_ring_thickness = 2 o_ring_inner_diameter = 170 # cut the o-ring groove top_piece = top_piece.faces("<Z").workplane(**u.cobb).mk_groove( ring_cs=o_ring_thickness, follow_pending_wires=False, ring_id=o_ring_inner_diameter, gland_x=array_x_length + groove_x_pad, gland_y=array_y_length + groove_y_pad, hardware=hardware) # cut the electrical contact screw mount holes vc_e_screw_spacing = 15 vc_e_screw_center_offset = 10 vc_e_screw_hole_depth = 12 vc_e_screw_screw_length = 8 vc_e_srew_type = "M3-0.5" e_dummy = SetScrew(vc_e_srew_type, fastener_type="iso4026", length=vc_e_screw_screw_length, simple=no_threads) # mark these chuck electrical connection screw holes in engineering drawing as M3x0.5 top_piece = top_piece.faces("<X").workplane(**u.cobb).center( vc_e_screw_center_offset, 0).rarray(vc_e_screw_spacing, 1, 2, 1).tapHole(e_dummy, depth=vc_e_screw_hole_depth) aso.add(btm_piece, name=plate_name, color=color) aso.add(top_piece, name=vac_name, color=color) aso.add(hardware.toCompound(), name="hardware", color=cadquery.Color(hardware_color))
def build(self, stacks_to_build: List[str] = [""]): if stacks_to_build == [""]: # build them all by default stacks_to_build = [x["name"] for x in self.stacks] drawing_layers_needed = [] for stack_instructions in self.stacks: if stack_instructions["name"] in stacks_to_build: for stack_layer in stack_instructions["layers"]: drawing_layers_needed += stack_layer["drawing_layer_names"] if "edge_case" in stack_layer: drawing_layers_needed.append(stack_layer["edge_case"]) drawing_layers_needed_unique = list(set(drawing_layers_needed)) # all the wires we'll need here wires = self.get_wires(self.sources, drawing_layers_needed_unique) stacks = {} for stack_instructions in self.stacks: # asy = cadquery.Assembly() asy = None if stack_instructions["name"] in stacks_to_build: # asy.name = stack_instructions["name"] z_base = 0 for stack_layer in stack_instructions["layers"]: t = stack_layer["thickness"] boundary_layer_name = stack_layer["drawing_layer_names"][ 0] # boundary layer must always be the first one listed w0 = wires[boundary_layer_name][0] wp = CQ().sketch().face(w0) for w in wires[boundary_layer_name][1::]: wp = wp.face(w, mode="s") wp = wp.finalize().extrude(t) # the workpiece is now made wp = wp.faces(">Z").sketch() if "array" in stack_layer: array_points = stack_layer["array"] else: array_points = [(0, 0, 0)] for drawing_layer_name in stack_layer[ "drawing_layer_names"][1:]: some_wires = wires[drawing_layer_name] for awire in some_wires: wp = wp.push(array_points).face( awire, mode="a", ignore_selection=False) wp = wp.faces() if "edge_case" in stack_layer: edge_wire = wires[stack_layer["edge_case"]][0] wp = wp.face(edge_wire, mode="i") wp = wp.clean() # wp = wp.finalize().cutThruAll() # this is a fail, but should work wp = wp.finalize().extrude(-t, combine="cut") new = wp.translate([0, 0, z_base]) if asy is None: # some silly hack needed to work around https://github.com/CadQuery/cadquery/issues/993 asy = cadquery.Assembly(new, name=stack_layer["name"], color=cadquery.Color( stack_layer["color"])) # asy.name = stack_instructions["name"] else: asy.add(new, name=stack_layer["name"], color=cadquery.Color(stack_layer["color"])) z_base = z_base + t stacks[stack_instructions["name"]] = asy return stacks
def _makeNegative(center): """ Generates the pocket shape we'll be cutting out """ # the connector pocket's dimensions pocket_w = connector_width + con_clearance * 2 pocket_l = con_len + con_clearance * 2 pocket_d = connector_height + con_clearance # find the source thing's thickness at the cut point swiss = CQ(self.plane).add(self.findSolid()) cheese = CQ(self.plane).add(self.findSolid()).pushPoints( [center]).circle(0.5).cutThruAll() core = swiss.cut(cheese) this_thikness = u.find_length(core, along="normal", bb_method=False) min_thickness = pocket_d + min_gp_connector_pocket_spacing + gp_depth # check that it's thick enough here if this_thikness < min_thickness: raise (ValueError( f"The part is too thin (thickness = {this_thikness}) at {center} to cut the PCB pocket" )) # make a box to subtract from start_box = CQ("XY").box(100, 100, this_thikness, centered=(True, True, False)) # make a simple pocket that we'll use for the chamfer operation result = start_box.faces("<Z").rect(pocket_w, pocket_l).cutBlind(pocket_d) # chamfer the connector edge result = result.faces("<Z").edges("not(<X or >X or <Y or >Y)").chamfer( chamfer_length) # now make the undercut pocket CQ.undercutRelief2D = u.undercutRelief2D result = result.faces("<Z").workplane().undercutRelief2D( pocket_l, pocket_w, diameter=r * 2, angle=90, kind=kind).cutBlind(pocket_d) # cut out the glue pocket slot_width = c.pcb_thickness + 2 * gp_buffer slot_len = pcb_len + slot_width result = result.faces(">Z").workplane().slot2D( slot_len, slot_width, angle=90).cutBlind(-gp_depth) # cut out the pcb passthrough slot slot_width = c.pcb_thickness + 2 * pcb_clearance slot_len = pcb_len + slot_width result = result.faces(">Z").workplane().slot2D(slot_len, slot_width, angle=90).cutThruAll() # invert the geometry and rotate the negative negative = start_box.cut(result) negative = negative.rotate((0, 0, 0), (0, 0, 1), angle) to_cut = negative.findSolid().locate(center) to_cut = to_cut.mirror("XY") return to_cut
def _make_pt(what): """build a passthrough component""" # this copies some logic in the eachpoint() function so that we can use each() which is safer base_plane = self.plane base = base_plane.location if isinstance(what, (cq.Vector, cq.Shape)): loc = base.inverse * cq.Location(base_plane, what.Center()) elif isinstance(what, cq.Sketch): loc = base.inverse * cq.Location(base_plane, what._faces.Center()) else: loc = what hardware = cadquery.Assembly() passthrough = CQ().add(passthrough_face) passthrough = passthrough.wires().toPending().extrude( -part_thickness) # extrude the bulk slotd = pcbt + 2 * min_gap passthrough = passthrough.workplane( centerOption="ProjectedOrigin").slot2D( length=board_width + slotd / 2, diameter=slotd, angle=0).cutThruAll() # cut the pcb slot # TODO: retool some geometry because this cutout could possibly interfere with the oring gland for thick PCBs # cut the oring groove cq.Workplane.mk_groove = groovy.mk_groove oring_path = o_face.outerWire().translate((0, 0, -part_thickness)) passthrough = passthrough.faces("<<Z").workplane( **u.copo).add(oring_path).toPending().mk_groove(ring_cs=oring_cs, hardware=hardware) # cut the fastening screw holes passthrough = passthrough.faces(">Z").workplane( **u.copo, origin=(0, 0, 0)).pushPoints(fhps).clearanceHole(fix_scr, fit="Close", baseAssembly=hardware) # add the support towers in_post_length = wall_depth + board_inner_depth passthrough = passthrough.faces(">Z").workplane( **u.copo, origin=(0, 0, 0)).sketch().push(sbpts).rect( *support_block).finalize().extrude(-in_post_length) passthrough = passthrough.faces(">Z").workplane( **u.copo, origin=(0, 0, 0)).sketch().push(sbpts).rect( *support_block).finalize().extrude(board_outer_depth) # mount holes pcb_center_z = ((board_outer_depth) - (wall_depth + board_inner_depth)) / 2 passthrough = passthrough.faces("+Y").faces(">>Z").workplane( **u.copo, origin=(0, 0, pcb_center_z)).rarray( board_width - 2 * pt_pcb_mount_hole_offset[1], board_inner_depth + board_outer_depth + wall_depth - 2 * pt_pcb_mount_hole_offset[0], 2, 2).clearanceHole(pcb_scr, fit="Close", counterSunk=False) passthrough = passthrough.edges("<<Z or >>Z").edges("|Y").fillet( pcb_corner) passthrough = passthrough.edges( "<<Z[-1] or <<Z[-2] or <<Z[-3] or >>Z[-1] or >>Z[-2] or >>Z[-3]" ).chamfer(0.5) if hw_asy is not None: hw_asy.add(hardware, loc=base * loc) return passthrough.findSolid().moved(base * loc)
def build(self, stacks_to_build: List[str] = [""]): if stacks_to_build == [""]: # build them all by default stacks_to_build = [x["name"] for x in self.stacks] drawing_layers_needed = [] for stack_instructions in self.stacks: if stack_instructions["name"] in stacks_to_build: for stack_layer in stack_instructions["layers"]: drawing_layers_needed += stack_layer["drawing_layer_names"] if "edge_case" in stack_layer: drawing_layers_needed.append(stack_layer["edge_case"]) drawing_layers_needed_unique = list(set(drawing_layers_needed)) # all the faces we'll need here layers = self.get_layers(self.sources, drawing_layers_needed_unique) self._layers = layers stacks = {} for stack_instructions in self.stacks: asy = cadquery.Assembly() # asy = None if stack_instructions["name"] in stacks_to_build: asy.name = stack_instructions["name"] z_base = 0 for stack_layer in stack_instructions["layers"]: t = stack_layer["thickness"] boundary_layer_name = stack_layer["drawing_layer_names"][ 0] # boundary layer must always be the first one listed layer_comp = cadquery.Compound.makeCompound( layers[boundary_layer_name].faces().vals()) if "array" in stack_layer: array_points = stack_layer["array"] else: array_points = [(0, 0, 0)] if len(stack_layer["drawing_layer_names"]) == 1: wp = CQ().sketch().push(array_points).face( layer_comp, mode="a", ignore_selection=False) else: wp = CQ().sketch().face(layer_comp, mode="a", ignore_selection=False) wp = wp.finalize().extrude( t) # the workpiece base is now made if len(stack_layer["drawing_layer_names"]) > 1: wp = wp.faces(">Z").workplane( centerOption="ProjectedOrigin").sketch() for drawing_layer_name in stack_layer[ "drawing_layer_names"][1:]: layer_comp = cadquery.Compound.makeCompound( layers[drawing_layer_name].faces().vals()) wp = wp.push(array_points).face( layer_comp, mode="a", ignore_selection=False) wp = wp.faces() if "edge_case" in stack_layer: edge_layer_name = stack_layer["edge_case"] layer_comp = cadquery.Compound.makeCompound( layers[edge_layer_name].faces().vals()) es = CQ().sketch().face(layer_comp) wp = wp.face(es.faces(), mode="i") wp = wp.clean() # wp = wp.finalize().cutThruAll() # this is a fail, but should work. if it's not a fail is slower than the below line wp = wp.finalize().extrude(-t, combine="cut") # give option to override calculated z_base if "z_base" in stack_layer: z_base = stack_layer["z_base"] new = wp.translate([0, 0, z_base]) asy.add(new, name=stack_layer["name"], color=cadquery.Color(stack_layer["color"])) z_base = z_base + t stacks[stack_instructions["name"]] = asy return stacks